/**
http://homes.cs.washington.edu/~djg/teachingMaterials/spac/sophomoricParallelismAndConcurrency.pdf

*/
import java.util.concurrent.ForkJoinPool;
import java.util.concurrent.RecursiveTask;
import java.util.Random;

class SumArray extends RecursiveTask<Integer>
{
   static int SEQUENTIAL_CUTOFF = 1_000;

   int lo;
   int hi;
   int[] arr;


   SumArray(int[] a, int l, int h)
   {
      arr=a; lo=l; hi=h;
   }

   public Integer compute()
   {
      if (hi - lo <= SEQUENTIAL_CUTOFF)
      {
         int ans = 0;
         for (int i=lo; i < hi; ++i)
            ans += arr[i];
         return ans;
      }
      else
      {
         SumArray left  = new SumArray(arr,lo,(hi+lo)/2);
         SumArray right = new SumArray(arr,(hi+lo)/2,hi);

         left.fork();
         int rightAns = right.compute();
         int  leftAns = left.join();
         return leftAns + rightAns;
      }
   }
}


class C
{
 //static final ForkJoinPool fjPool = new ForkJoinPool();  // needed by Java 7

   static int sum(int[] array)
   {
      SumArray t = new SumArray(array, 0, array.length);

      // Put item t into the work queue.
      return ForkJoinPool.commonPool().invoke(t);                  // Java 8
    //return fjPool.invoke(new SumArray(array, 0, array.length));  // Java 7

   }
}


public class Section_3_4b
{
   public static final int PROBLEM_SIZE = 100_000_000;
   public static int numbers[] = new int[PROBLEM_SIZE];

   public static void main(String[] args)
   {
      Random generator = new Random();
      for (int i = 0; i < numbers.length; i++)
         numbers[i] = generator.nextInt();

      long startTime;
      long stopTime;

      long result = 0;

      SumArray.SEQUENTIAL_CUTOFF = 5000;  // BE SURE TO EXPERIMENT WITH THIS!
      System.out.println("Starting Fork/Join Pool...");
      startTime = System.currentTimeMillis();
         result = C.sum(numbers);
      stopTime = System.currentTimeMillis();
      System.out.println(" Fork-join sum: " + result);
      System.out.println(" Fork-join solution time: " + (stopTime - startTime));
      System.out.println("ForkJoinPool: " + ForkJoinPool.commonPool().toString());
    //System.out.println("ForkJoinPool: " + Main.fjPool.toString());
   }
}
